<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: modelo_llamadas_nhc_5.xml */
/* Generado: 2014-11-25 13:07:49 */

/* Busqueda de registros de la tabla cr_vista_morosos. */
abstract class BaseCr_vista_morososFN extends Cr_vista_morososBN
{
    /* Declaracion de constantes */
    const TipoPrestamo = "TIPOPRESTAMO";
    const NumeroPrestamo = "NUMEROPRESTAMO";
    const Moneda = "MONEDA";
    const MontoPrestado = "MONTOPRESTADO";
    const SaldoPrestamo = "SALDOPRESTAMO";
    const FechaInicio = "FECHAINICIO";
    const FechaFinal = "FECHAFINAL";
    const IdMercado = "IDMERCADO";
    const NombreMercado = "NOMBREMERCADO";
    const IdCliente = "IDCLIENTE";
    const NombreCliente = "NOMBRECLIENTE";
    const Dni = "DNI";

    public $a_Condition = array();
    public $a_OrderBy = array();

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        /*
    	$o_DBConnect = Conexion::getConexion();
        //$o_Resource = $o_DBConnect->getResource();
        $o_Resource = $o_DBConnect;
        */
         $o_Resource=Conexion::getConexion();
         
         
        return $o_Resource;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "TipoPrestamo AS TipoPrestamo, ";
        $s_SQLQuery .= "NumeroPrestamo AS NumeroPrestamo, ";
        $s_SQLQuery .= "Moneda AS Moneda, ";
        $s_SQLQuery .= "MontoPrestado AS MontoPrestado, ";
        $s_SQLQuery .= "SaldoPrestamo AS SaldoPrestamo, ";
        $s_SQLQuery .= "FechaInicio AS FechaInicio, ";
        $s_SQLQuery .= "FechaFinal AS FechaFinal, ";
        $s_SQLQuery .= "IdMercado AS IdMercado, ";
        $s_SQLQuery .= "NombreMercado AS NombreMercado, ";
        $s_SQLQuery .= "IdCliente AS IdCliente, ";
        $s_SQLQuery .= "NombreCliente AS NombreCliente, ";
        $s_SQLQuery .= "Dni AS Dni ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value, $b_Comillas=true )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value, "COMILLAS" => $b_Comillas );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece los valores desde un objeto Cr_vista_morososBN */
    public function setByBN( Cr_vista_morososBN $o_Cr_vista_morososBN )
    {
        if ( !is_null( $o_Cr_vista_morososBN->getTipoPrestamo() ) )
        {
            $this->setTipoPrestamo( $o_Cr_vista_morososBN->getTipoPrestamo() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getNumeroPrestamo() ) )
        {
            $this->setNumeroPrestamo( $o_Cr_vista_morososBN->getNumeroPrestamo() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getMoneda() ) )
        {
            $this->setMoneda( $o_Cr_vista_morososBN->getMoneda() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getMontoPrestado() ) )
        {
            $this->setMontoPrestado( $o_Cr_vista_morososBN->getMontoPrestado() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getSaldoPrestamo() ) )
        {
            $this->setSaldoPrestamo( $o_Cr_vista_morososBN->getSaldoPrestamo() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getFechaInicio() ) )
        {
            $this->setFechaInicio( $o_Cr_vista_morososBN->getFechaInicio() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getFechaFinal() ) )
        {
            $this->setFechaFinal( $o_Cr_vista_morososBN->getFechaFinal() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getIdMercado() ) )
        {
            $this->setIdMercado( $o_Cr_vista_morososBN->getIdMercado() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getNombreMercado() ) )
        {
            $this->setNombreMercado( $o_Cr_vista_morososBN->getNombreMercado() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getIdCliente() ) )
        {
            $this->setIdCliente( $o_Cr_vista_morososBN->getIdCliente() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getNombreCliente() ) )
        {
            $this->setNombreCliente( $o_Cr_vista_morososBN->getNombreCliente() );
        }
        if ( !is_null( $o_Cr_vista_morososBN->getDni() ) )
        {
            $this->setDni( $o_Cr_vista_morososBN->getDni() );
        }
    }

    /* Busca un registro por su llave primaria */
    public function selectByPK(  )
    {
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM cr_vista_morosos ";
        $s_SQLQuery .= "LIMIT 1;";

        $o_Cr_vista_morososBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_vista_morososBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_Cr_vista_morososBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getTipoPrestamo() ) ) $s_SQLQuery .= "TipoPrestamo = '".$this->getTipoPrestamo()."' AND ";
        if ( !is_null( $this->getNumeroPrestamo() ) ) $s_SQLQuery .= "NumeroPrestamo = ".$this->getNumeroPrestamo()." AND ";
        if ( !is_null( $this->getMoneda() ) ) $s_SQLQuery .= "Moneda = '".$this->getMoneda()."' AND ";
        if ( !is_null( $this->getMontoPrestado() ) ) $s_SQLQuery .= "MontoPrestado = ".$this->getMontoPrestado()." AND ";
        if ( !is_null( $this->getSaldoPrestamo() ) ) $s_SQLQuery .= "SaldoPrestamo = ".$this->getSaldoPrestamo()." AND ";
        if ( !is_null( $this->getFechaInicio() ) ) $s_SQLQuery .= "FechaInicio = '".$this->getFechaInicio()."' AND ";
        if ( !is_null( $this->getFechaFinal() ) ) $s_SQLQuery .= "FechaFinal = '".$this->getFechaFinal()."' AND ";
        if ( !is_null( $this->getIdMercado() ) ) $s_SQLQuery .= "IdMercado = ".$this->getIdMercado()." AND ";
        if ( !is_null( $this->getNombreMercado() ) ) $s_SQLQuery .= "NombreMercado = '".$this->getNombreMercado()."' AND ";
        if ( !is_null( $this->getIdCliente() ) ) $s_SQLQuery .= "IdCliente = ".$this->getIdCliente()." AND ";
        if ( !is_null( $this->getNombreCliente() ) ) $s_SQLQuery .= "NombreCliente = '".$this->getNombreCliente()."' AND ";
        if ( !is_null( $this->getDni() ) ) $s_SQLQuery .= "Dni = '".$this->getDni()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                if( $a_Condition['COMILLAS'] )
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else 
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM cr_vista_morosos WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        
        $num_rows = 0;
        if ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $num_rows = $a_SQLRow->cnt;
        }
        return $num_rows;
    }

    /* Busca varios registros por los campos establecidos */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM cr_vista_morosos WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";
//echo $s_SQLQuery;
        $a_Cr_vista_morososBN = null;
        $o_Resource = $this->getConnect();
        $o_SQLResult = mysql_query( $s_SQLQuery, $o_Resource );
        if ( $o_SQLResult === false )
        {
            throw new Exception( mysql_error() );
        }
        while ( $a_SQLRow = mysql_fetch_object( $o_SQLResult ) )
        {
            $o_Cr_vista_morososBN = $this->insertObjectBN( $a_SQLRow );
            $a_Cr_vista_morososBN[] = $o_Cr_vista_morososBN;
        }
        return $a_Cr_vista_morososBN;
    }

    /* Devuelve un objeto Cr_vista_morososBN desde un objeto propel */
    public function insertObjectBN( $o_Cr_vista_morosos )
    {
        $o_Cr_vista_morososBN = new Cr_vista_morososBN();
        if ( !is_null( $o_Cr_vista_morosos->TipoPrestamo ) ) $o_Cr_vista_morososBN->setTipoPrestamo( $o_Cr_vista_morosos->TipoPrestamo );
        if ( !is_null( $o_Cr_vista_morosos->NumeroPrestamo ) ) $o_Cr_vista_morososBN->setNumeroPrestamo( ( integer ) $o_Cr_vista_morosos->NumeroPrestamo );
        if ( !is_null( $o_Cr_vista_morosos->Moneda ) ) $o_Cr_vista_morososBN->setMoneda( $o_Cr_vista_morosos->Moneda );
        if ( !is_null( $o_Cr_vista_morosos->MontoPrestado ) ) $o_Cr_vista_morososBN->setMontoPrestado( ( float ) $o_Cr_vista_morosos->MontoPrestado );
        if ( !is_null( $o_Cr_vista_morosos->SaldoPrestamo ) ) $o_Cr_vista_morososBN->setSaldoPrestamo( ( float ) $o_Cr_vista_morosos->SaldoPrestamo );
        if ( !is_null( $o_Cr_vista_morosos->FechaInicio ) ) $o_Cr_vista_morososBN->setFechaInicio( utilTimestamp::getTimestamp( $o_Cr_vista_morosos->FechaInicio, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_vista_morosos->FechaFinal ) ) $o_Cr_vista_morososBN->setFechaFinal( utilTimestamp::getTimestamp( $o_Cr_vista_morosos->FechaFinal, "Y-m-d H:i:s" ) );
        if ( !is_null( $o_Cr_vista_morosos->IdMercado ) ) $o_Cr_vista_morososBN->setIdMercado( ( integer ) $o_Cr_vista_morosos->IdMercado );
        if ( !is_null( $o_Cr_vista_morosos->NombreMercado ) ) $o_Cr_vista_morososBN->setNombreMercado( $o_Cr_vista_morosos->NombreMercado );
        if ( !is_null( $o_Cr_vista_morosos->IdCliente ) ) $o_Cr_vista_morososBN->setIdCliente( ( integer ) $o_Cr_vista_morosos->IdCliente );
        if ( !is_null( $o_Cr_vista_morosos->NombreCliente ) ) $o_Cr_vista_morososBN->setNombreCliente( $o_Cr_vista_morosos->NombreCliente );
        if ( !is_null( $o_Cr_vista_morosos->Dni ) ) $o_Cr_vista_morososBN->setDni( $o_Cr_vista_morosos->Dni );
        return $o_Cr_vista_morososBN;
    }
}
?>